import java.awt.*;

public class DrawingObjectPlain implements IDrawingObject
{
    private DrawingEntityPlain _airplain = null;
    public DrawingObjectPlain(DrawingEntityPlain aircraft){
        _airplain = aircraft;
    }
    public DrawingEntityPlain getAirPlane() {
        return _airplain;
    }

    public void MoveObject(Direction direction) {
        if(_airplain == null) return;
        _airplain.MoveTransport(direction);
    }

    @Override
    public float getStep() {
        if(_airplain == null) return 0;
        return _airplain.Airplane.Step;
    }

    public void SetObject(int x, int y, int width, int height)
    {
        _airplain.SetPosition(x, y, width, height);
    }
    public void DrawningObject(Graphics2D g)
    {
        _airplain.DrawTransport(g);
    }

    @Override
    public Point GetLeftTop() {
        if(_airplain == null) return new Point(0,0);
        return _airplain.getLeftTop();
    }

    @Override
    public Point GetRightBottom() {
        if(_airplain == null) return new Point(0,0);
        return _airplain.getRightBottom();
    }
}