import java.awt.*;

public class DrawingRadarPlain extends DrawingEntityPlain
{
    public DrawingRadarPlain(int speed, float weight, Color bodyColor, Color dopColor, boolean Radar, boolean OilBox)
    {
        super(speed, weight, bodyColor, 240, 150);
        Airplane = new EntityRadarPlain(speed, weight, bodyColor, dopColor, Radar, OilBox);
    }
    public DrawingRadarPlain(EntityAirPlane entityAirPlane, IDrawingPorthole iDrawingPorthole){
        super(entityAirPlane,iDrawingPorthole);
    }
    @Override
    public void DrawTransport(Graphics2D g)
    {
        if (!(Airplane instanceof EntityRadarPlain))
        {
            return;
        }

        EntityRadarPlain radarPlain = (EntityRadarPlain)Airplane;
        super.DrawTransport(g);
        g.setPaint(radarPlain.DopColor);
        if (radarPlain.Radar)
        {
            g.fillRect( (int)_startPosX +110, (int)_startPosY + 40, 20, 20);
            g.fillOval( (int)_startPosX + 80, (int)_startPosY + 26, 80, 20);
        }

        if (radarPlain.OilBox) {
            g.fillRect((int) _startPosX + 80, (int) _startPosY + 96, 40, 20);
            g.fillRect((int) _startPosX, (int) _startPosY + 30, 60, 20);
        }
    }
}
