import java.awt.*;

public class DrawingSquarePorthole implements IDrawingPorthole {
    private Porthole PortholeCount;
    private Color color;

    public DrawingSquarePorthole(int count, Color bodyColor) {
        setCount(count);
        color = bodyColor;
    }

    @Override
    public void setCount(int count) {
        if(count <= 10) PortholeCount = Porthole.Ten;
        else if(count >= 30) PortholeCount = Porthole.Twenty;
        else PortholeCount = Porthole.Thirty;
    }

    public void draw(Graphics2D g, int startPosX, int startPosY) {
        g.setPaint(color);
        int count = 0;
        int i = -1;
        int j = 0;
        while(true)
        {
            if(i==14) {
                i = 0;
                j=30;
            }
            else   i++;
            if(PortholeCount == Porthole.Ten && count==10) break;
            else if(PortholeCount == Porthole.Twenty && count==20) break;
            else if(PortholeCount == Porthole.Thirty && count==30) break;
            g.setPaint(Color.black);
            g.drawRect(startPosX+i*12 , startPosY + j, 10, 10);
            g.setPaint(color);
            g.fillRect(startPosX+i*12, startPosY + j, 10, 10);
            count++;
        }
    }
}