import java.awt.*;

public class DrawingTrianglePorthole implements IDrawingPorthole {
    private Porthole PortholeCount;
    private Color color;

    public DrawingTrianglePorthole(int count, Color bodyColor) {
        setCount(count);
        color = bodyColor;
    }

    @Override
    public void setCount(int count) {
        if(count <= 10) PortholeCount = Porthole.Ten;
        else if(count >= 30) PortholeCount = Porthole.Twenty;
        else PortholeCount = Porthole.Thirty;
    }

    private void drawEngine(Graphics2D g, int x, int y) {

        g.setColor(Color.black);
        g.drawRect(x+2, y, 4, 5);
        g.drawRect(x, y+5, 5, 5);
        g.drawRect(x+5, y+5, 5, 5);
        g.setPaint(color);
        g.fillRect(x+2, y, 4, 5);
        g.fillRect(x, y+5, 5, 5);
        g.fillRect(x+5, y+5, 5, 5);

    }

    public void draw(Graphics2D g, int startPosX, int startPosY) {
        int count = 0;
        int i = -1;
        int j = 0;
        while(true)
        {
            if(i==14) {
                i = 0;
                j=30;
            }
            else   i++;
            if(PortholeCount == Porthole.Ten && count==10) break;
            else if(PortholeCount == Porthole.Twenty && count==20) break;
            else if(PortholeCount == Porthole.Thirty && count==30) break;
            drawEngine(g,startPosX+i*12 , startPosY + j);
            count++;
        }
    }
}