import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormAirPlane extends JDialog implements Form {
    private JButton createButton;
    private JButton upButton;
    private JButton rightButton;
    private JButton downButton;
    private JButton leftButton;
    private JPanel mainPanel;
    private JPanel DrawPlace;
    private JLabel speedLabel;
    private JLabel weightLabel;
    private JLabel colorLabel;
    private JButton createModifButton;
    private JButton selectButton;
    DrawingEntityPlain _airPlane;
    private DrawingEntityPlain selectedPlane;
    public FormAirPlane() {}

    public FormAirPlane(DrawingEntityPlain aircraft) {
        _airPlane = aircraft;
    }
    public DrawingEntityPlain getSelectedPlane() {
        return selectedPlane;
    }

    public void run() {
        add(mainPanel);
        Canvas canv = new Canvas(this);
        DrawPlace.add(canv);


        createButton.addActionListener(e -> {
            Dimension canvSize = canv.getSize();
            Random rnd = new Random();

            Color color = JColorChooser.showDialog(this, "Цвет", Color.BLACK);

            if(color == null) color = Color.BLACK;

            _airPlane = new DrawingEntityPlain(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000), color);

            _airPlane.SetPosition((int)rnd.nextInt(10, 100), (int)rnd.nextInt(10, 100), canvSize.width, canvSize.height);

            Color bodyColor = _airPlane.Airplane.BodyColor;
            String colorString = "(" + bodyColor.getRed() + ", " + bodyColor.getGreen() + ", " + bodyColor.getBlue() + ")";

            speedLabel.setText("Скорость: " + _airPlane.Airplane.Speed + "   ");
            weightLabel.setText("Вес: " + _airPlane.Airplane.Weight + "   ");
            colorLabel.setText("Цвет: " + colorString);

            canv.repaint();
        });

        createModifButton.addActionListener(e -> {

            Dimension canvSize = canv.getSize();
            Random rnd = new Random();

            Color color = JColorChooser.showDialog(this, "Цвет", Color.BLACK);
            Color dopColor = JColorChooser.showDialog(this, "Цвет", Color.BLACK);

            if(color == null) color = Color.BLACK;
            if(dopColor == null) dopColor = Color.BLACK;

            _airPlane = new DrawingRadarPlain(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000),
                    color, dopColor,
                    rnd.nextInt(0, 2) == 1, rnd.nextInt(0, 2) == 1);

            _airPlane.SetPosition((int)rnd.nextInt(10, 100), (int)rnd.nextInt(10, 100), canvSize.width, canvSize.height);

            Color bodyColor = _airPlane.Airplane.BodyColor;
            String colorString = "(" + bodyColor.getRed() + ", " + bodyColor.getGreen() + ", " + bodyColor.getBlue() + ")";

            speedLabel.setText("Скорость: " + _airPlane.Airplane.Speed + "   ");
            weightLabel.setText("Вес: " + _airPlane.Airplane.Weight + "   ");
            colorLabel.setText("Цвет: " + colorString);

            canv.repaint();
        });

        selectButton.addActionListener(e -> {
            selectedPlane = _airPlane;
            dispose();
        });
        addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                if(_airPlane == null) return;
                _airPlane.ChangeBorders(canv.getSize().width, canv.getSize().height);
            }
        });

        upButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Up);
            canv.repaint();
        });
        rightButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Right);
            canv.repaint();
        });
        downButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Down);
            canv.repaint();
        });
        leftButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Left);
            canv.repaint();
        });
    }
    @Override
    public void Draw(Graphics2D g) {
        if(_airPlane == null) return;
        _airPlane.DrawTransport(g);
    }
}