import java.util.LinkedHashMap;
import java.util.List;

public class MapsCollection
{
    public LinkedHashMap<String, MapWithSetPlane<DrawingObjectPlain, AbstractMap>> _mapStorages;
    private int _pictureWidth;
    private int _pictureHeight;

    public List<String> getKeys() { return _mapStorages.keySet().stream().toList(); }

    public MapsCollection(int pictureWidth, int pictureHeight)
    {
        _mapStorages = new LinkedHashMap<>();
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }

    public DrawingObjectPlain Indexator (String key, int pos){
        return _mapStorages.get(key).getPlane(pos);
    }
    public void AddMap(String name, AbstractMap map)
    {
        boolean check = _mapStorages.containsKey(name);
        if (check) return;

        _mapStorages.put(name, new MapWithSetPlane(_pictureWidth, _pictureHeight, map));
    }

    public void DelMap(String name)
    {
        _mapStorages.remove(name);
    }

    public MapWithSetPlane<DrawingObjectPlain, AbstractMap> getMap(String name)
    {
        return _mapStorages.getOrDefault(name, null);
    }
}