import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class formPlaneGenerator implements Form {
    private JButton generateButton;
    private JPanel drawPanel;
    private JPanel mainPanel;
    private Canvas canv = new Canvas(this);

    private DrawingEntityPlain airplane;
    private AirplaneMixer<EntityAirPlane, IDrawingPorthole> mixer = new AirplaneMixer<>(10, 20);
    private JFrame jframe = getFrame();

    private JFrame getFrame() {
        JFrame frame = new JFrame();
        frame.setVisible(true);
        frame.setBounds(300, 100, 400, 300);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        return frame;
    }

    public void run() {
        jframe.add(mainPanel);
        drawPanel.add(canv);

        Random rnd = new Random();

        for(int i = 0; i < 10; ++i) {
            if(rnd.nextBoolean()) {
                mixer.add(new EntityAirPlane(rnd.nextInt(100, 250), rnd.nextInt(1000, 2000),
                        new Color(
                                rnd.nextInt(0, 255),
                                rnd.nextInt(0, 255),
                                rnd.nextInt(0, 255)
                        )));
                continue;
            }

            mixer.add(new EntityRadarPlain(rnd.nextInt(100, 250), rnd.nextInt(1000, 2000),
                    new Color(
                            rnd.nextInt(0, 255),
                            rnd.nextInt(0, 255),
                            rnd.nextInt(0, 255)
                    ),
                    new Color(
                            rnd.nextInt(0, 255),
                            rnd.nextInt(0, 255),
                            rnd.nextInt(0, 255)
                    ),
                    rnd.nextBoolean(), rnd.nextBoolean()
            ));
        }

        for(int i = 0; i < 20; ++i) {
            Color randomColor = new Color(
                    rnd.nextInt(0, 255),
                    rnd.nextInt(0, 255),
                    rnd.nextInt(0, 255));

            mixer.add(PortholeFabric.createRandom(randomColor));
        }

        generateButton.addActionListener(e -> {
            Dimension canvSize = canv.getSize();
            airplane = mixer.constructAirplane(canvSize.width, canvSize.height);
            canv.repaint();
        });
    }

    @Override
    public void Draw(Graphics2D g) {
        if(airplane == null) return;
        airplane.DrawTransport(g);
    }
}